#def nqueens(n) = queens(nil,1..n,0,n) whererec
#
#  queens(s,l,i,j) = if null l then s                  #no unplaced queens left
#                    else if j=i then "no solution"           #run out of perms
#                    else let result=if tryout(s,hd l,i) then  #add to solution
#                                       queens(s:(hd l.nil),tl l,i+1,n)
#                                    else "no solution" in
#                         if result <> "no solution" then result    #pass it up 
#                         else queens(s,tl l:(hd l.nil),i,j-1),  #try next perm
#  tryout(l,x,i) =  if i=0 then T
#                    else if(x-hd l = i)or(hd l-x = i)then F
#                    else tryout(tl l,x,i-1);

fn tryout(l x i)
{
  if (equ(i 0))
  {
    return(1)
  }
  elsif (equ(abs(sub(x head(l))) i))
  {
    return (0)
  }
  else
  {
    tryout(tail(l) x sub(i 1))
  }
}


fn queens (s l i j n)
{
  if (equ (l {}))
  {
    return (s)
  }
  if (equ(j i))
  {
    return (0)
  }
  if (tryout(s head(l) i))
  {
    if (queens(concat(s head(l)) tail(l) add(i 1) n n))
    {
      return (last_result())
    }
    else
    {
      queens(s concat(tail(l) head(l)) i sub(j 1) n)
    }
  }
  else
  {
    queens(s concat(tail(l) head(l)) i sub(j 1) n)
  }
}

display (queens({} {1,2,3,4,5,6,7,8,9,10} 0 10 10 ))

